unit telefoon;
//http://www.mozilla.org/MPL/MPL-1.1.html


{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: telefoon.pas, released October 18, 2002.

The Initial Developer of the Original Code is Remko Weingarten
Portions created by Remko Weingarten are Copyright (C) 2002 Remko Weingarten}.
//All Rights Reserved.



interface

uses
  Windows, SysUtils, Classes, Controls, Forms,
  mmsystem, StdCtrls, Graphics, ExtCtrls, ComCtrls, NMUDP, dialogs,
  soundOut, soundIn, Messages, soundConverter, psock, mixing;

type 
  Tselfsound = procedure(var sound: pointer; var size: integer; var handled: boolean) of
  object;
type  
  TGeneralEvent = procedure(Sender: TObject; Text: string) of object;
type  
  TpingEvent = procedure(Sender: TObject; Text: string; pingisanswer: boolean;
    fromip: string; fromport: integer; Name: string) of object;
type 
  Tverbinding = (LERNOUT4, PCM8, GSM610, PCM22, PCM11, LERNOUT8);
type 
  Ttimerevent = procedure(Sender: TObject) of object;
type
  TTelefoon = class(TComponent)
  private

    factive: boolean;
    fip: string;
    fauthor: string;
    fsync: boolean;
    fmix: Taudio;
    frejected: Tgeneralevent;
    flocal: integer;
    fvolume: integer;
    fport: integer;
    nm: tnmudp;
    acmin1: Tacmin;
    fcalled: Tgeneralevent;
    fcodecerror: tgeneralevent;
    fwait: integer;
    fsoundclose: Ttimerevent;
    faccepted: tgeneralevent;
    acmout1: Tacmout;
    fverbinding: tverbinding;
    fzelf: boolean;
    Fstatus: Tgeneralevent;
    fsoundstart: Tgeneralevent;
    fselfsound: Tselfsound;
    Fverzonden: Tgeneralevent;
    Fended: Tgeneralevent;
    fbellen: boolean;
    flocalip: string;
    fauto: boolean;
    ftimer: Ttimer;
    Fanswer: boolean;
    gip: string;
    gport: integer;
    fsms: Tgeneralevent;
    gconnect: tverbinding;
    Gzelf: boolean;
    nmping: Tnmudp;
    Fpinglocal: integer;
    Fpingremote: integer;
    fnoresponce: tgeneralevent;
    Fpingevent: Tpingevent;
    fpingrespond: boolean;
    fmute: boolean;
    fbeforesoundout: Tselfsound;
    fsoundrecieved: tgeneralevent;
    Fversie: string;

    { Private declarations }
  protected
    procedure helaas(Sender: TObject);
    function getvolume: integer;
    procedure setvolume(Value: integer);
    function getwait: integer;
    procedure setwait(Value: integer);
    procedure beller(var s: string);
    procedure showbericht(s: string);
    procedure setip(const Value: string);
    procedure setauthor(const Value: string);
    procedure setversion(const Value: string);
    procedure setport(const Value: integer);
    procedure setlocalport(const Value: integer);
    procedure setremotepingport(const Value: integer);
    procedure setlocalpingport(const Value: integer);
    procedure setactive(const Value: boolean);
    procedure setbellen(const Value: boolean);
    procedure nmDataSend(Sender: TObject);
    procedure nmStatus(Sender: TComponent; status: string);
    procedure ACMIn1BufferFull(Sender: TObject; Data: Pointer;
      Size: integer);
    procedure nmDataReceived(Sender: TComponent; NumberBytes: integer;
      FromIP: string; Port: integer);
    procedure pingReceivedd4(Sender: TComponent;
      NumberBytes: integer; FromIP: string);
    procedure pingReceived(Sender: TComponent; NumberBytes: integer;
      FromIP: string; Port: integer);
    procedure NMDataReceivedd4(Sender: TComponent;
      NumberBytes: integer; FromIP: string);

    procedure start;
    procedure stop;
    procedure answer;


    { Protected declarations }
  public
    bufferdelen: integer;
    messagesize: integer;
    Fsyncfactor: integer;
    function test: integer;
    function getsoundinlevel: longint;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure sendmessage(s: string);
    procedure placecall(ip: string);
    procedure vernieuwlocal;
    procedure ping(ip, naam: string);
    procedure answerincomming;
    procedure rejectincomming;
    function getmikevolume: integer;
    { Public declarations }
    property Active: boolean read factive write setactive default False;
  published
    property Remote_IP: string read fip write setip;
    property Remote_Port: integer read fport write setport;
    property Local_Port: integer read flocal write setlocalport;
    property Connection: Tverbinding read fverbinding write fverbinding default gsm610;
    property User_Chosen_Codec: boolean read fzelf write fzelf;
    property Author_Email: string read Fauthor write setauthor;
    property Calling: boolean read fbellen write setbellen default False;
    property Adopt_Settings_Off_Caller: boolean read fauto write fauto;
    property Auto_Answer: boolean read fanswer write fanswer;
    property Local_IP: string read flocalip write flocalip;
    property Local_Ping_Port: integer read fpinglocal write setlocalpingport;
    property Remote_Ping_port: integer read fpingremote write setremotepingport;
    property Ping_Auto_Respond: boolean read fpingrespond write fpingrespond;
    property Mute: boolean read fmute write fmute;
    property Auto_synchronise: boolean read fsync write fsync;
    property OnUdpStatus: Tgeneralevent read Fstatus write Fstatus;
    property OnDataSend: Tgeneralevent read Fverzonden write Fverzonden;
    property OnCalled: tgeneralevent read fcalled write fcalled;
    property OnConnectionEnded: tgeneralevent read fended write fended;
    property OnTextMessage: tgeneralevent read fsms write fsms;
    property OnDeviceOpenError: tgeneralevent read fcodecerror write fcodecerror;
    property OnCallAccepted: tgeneralevent read faccepted write faccepted;
    property OnPinnged: Tpingevent read fpingevent write fpingevent;
    property Volume: integer read getvolume write setvolume;
    property OnAudioDeviceOpen: Tgeneralevent read fsoundstart write fsoundstart;
    property Version: string read fversie write setversion;
    property OnCallRejected: Tgeneralevent read frejected write frejected;
    property WaitForconnectionTime: integer read getwait write setwait;
    property OnNoResponce: Tgeneralevent read fnoresponce write fnoresponce;
    property OnSoundRecieved: Tgeneralevent read Fsoundrecieved write fsoundrecieved;
    property OnSelfSound: Tselfsound read fselfsound write fselfsound;
    property OnSoundClose: Ttimerevent read fsoundclose write fsoundclose;
    property OnBeforeSoundout: Tselfsound read fbeforesoundout write fbeforesoundout;
    { Published declarations }
  end;

procedure Register;

implementation

constructor Ttelefoon.Create(AOwner: TComponent);
begin
  inherited Create(aowner);
  vernieuwlocal;
  fport := 8000;
  flocalip := '';
  fmix := Taudio.Create(self);
  factive := False;
  bufferdelen := 20;
  messagesize := 150;
  fmute := False;
  fbellen := False;
  fsyncfactor := 20;
  ftimer := ttimer.Create(self);
  ftimer.Enabled := False;
  ftimer.interval := 15000;
  fwait := 15000;
  ftimer.ontimer := helaas;
  fverbinding := gsm610;
  fauthor := 'remko_voip@prinsengracht.org';
  fanswer := True;
  fip := '127.0.0.1';
  flocal := 8000;
  fpinglocal := 8001;
  fpingremote := 8001;
  fsync := True;
  fauto := True;
  setversion(' ');
  nmping := Tnmudp.Create(self);
  nmping.localport := fpinglocal;
  nmping.RemotePort := fpingremote;
  nmping.RemoteHost := fip;
  nmping.ReportLevel := status_basic;
  {$IFNDEF VER120}
  nmping.OnDataReceived := pingReceived;
  {$else}
  nmping.OnDataReceived := pingReceivedd4;
  {$ENDIF}
  nm := Tnmudp.Create(self);
  nm.localport := flocal;
  nm.remotehost := fip;
  nm.remoteport := fport;
  nm.reportlevel := status_basic;
  acmin1 := Tacmin.Create(self);
  acmin1.buffersize := 100;
  acmin1.numbuffers := 4;
  setversion(' ');
  acmout1 := Tacmout.Create(self);
  acmout1.numbuffers := 4;
  acmin1.onbufferfull := ACMIn1BufferFull;
  {$IFNDEF VER120}
  nm.OnDataReceived := nmDataReceived;
  {$else}
  nm.OnDataReceived := nmDataReceivedd4;
  {$ENDIF}
  nm.onstatus := nmstatus;
  nm.ondatasend := nmdatasend;
end;

procedure Ttelefoon.vernieuwlocal;
var 
  t: tpowersock;
begin
  try
    t := tpowersock.Create(nil);
    flocalip := t.localip;
  finally
    t.Free
  end
end;


destructor Ttelefoon.Destroy;
begin
  try
    if calling then calling := False;
    if active then active := False;
  except
  end;
  ftimer.Enabled := False;
  ftimer.Free;
  acmout1.Close;
  acmin1.Close;
  acmin1.Free;
  fmix.Destroy;
  if assigned(fsoundclose) then fsoundclose(self);
  nm.Free;
  nmping.Free;
  acmout1.Free;
  inherited
end;

procedure Ttelefoon.helaas(Sender: TObject);
begin
  ftimer.Enabled := False;
  calling := False;
  if assigned(fnoresponce) then fnoresponce(Sender, 'no responce') 
  else 
    ShowMessage('No responce');
end;

  


procedure Ttelefoon.pingReceivedd4(Sender: TComponent;
  NumberBytes: integer; FromIP: string);
begin
  pingreceived(Sender, numberbytes, fromip, fport)
end;


procedure Ttelefoon.pingReceived(Sender: TComponent; NumberBytes: integer;
  FromIP: string; Port: integer);
var 
  k: Tmemorystream;
  s, naam: string;
  a: array[1..60] of char;
  i: integer;
  toevoegen: boolean;
  ip: string;
  ipadd: boolean;
  nietantwoorden: boolean;
  voegnaamtoe: boolean;
begin
  if numberbytes > 70 then exit;
  if numberbytes > 30 then nmping.ReadBuffer(a, numberbytes) 
  else 
    exit;
  s := '';
  toevoegen := False;
  nietantwoorden := False;
  i := 1;
  ipadd := False;
  ip := '';
  naam := '';
  voegnaamtoe := False;
  while i <= numberbytes do
  begin
    if a[i] = '@' then voegnaamtoe := False;
    if voegnaamtoe then naam := naam + a[i];
    if a[i] = 'I' then ipadd := True;
    if ((a[i] < '0') or (a[i] > '9')) and (a[i] <> '.') and (a[i] <> 'I') then
      ipadd := False;
    if (a[i] <> 'I') and ipadd then ip := ip + a[i];
    if (a[i] < '0') or (a[i] > '9') then 
    begin 
      toevoegen := False 
    end;
    if toevoegen then s := s + a[i];
    if a[i] = 'Q' then toevoegen := True;
    if a[i] = ';' then nietantwoorden := True;
    if a[i] = 'N' then voegnaamtoe := True;
    i := i + 1
  end;
  if assigned(fpingevent) then fpingevent(Sender, a, nietantwoorden, ip, port, naam);
  if fpingrespond and (not nietantwoorden) then
  begin
    if trim(s) <> '' then
      try
        fpingremote := StrToInt(s);
        nmping.RemotePort := StrToInt(s);
        nmping.RemoteHost := ip;
        if trim(flocalip) = '' then vernieuwlocal;
        s := 'I' + flocalip + 'P' + IntToStr(flocal) + 'V' + IntToStr(Ord(fverbinding)) +
          ';' + 'Q' + IntToStr(fpingremote);
        if factive then s := s + 'AT' 
        else 
          s := s + 'AF';
        if fanswer then s := s + 'OT' 
        else 
          s := s + 'OF';
        s := s + '@';
        for i := 1 to length(s) do a[i] := s[i];
        nmping.SendBuffer(a, 60);
      except
      end
  end;
end;








procedure Ttelefoon.NMDataReceivedd4(Sender: TComponent;
  NumberBytes: integer; FromIP: string);
begin
  nmdatareceived(Sender, numberbytes, fromip, fport)
end;


procedure Ttelefoon.nmDataReceived(Sender: TComponent; NumberBytes: integer;
  FromIP: string; Port: integer);
var 
  s: string;
  k: tmemorystream;
  p: pointer;
  groot: integer;
  h: boolean;
begin
  k := Tmemorystream.Create;
  k.Clear;
  try
    nm.ReadStream(k);
    if numberbytes = messagesize then
    begin
      setlength(s, messagesize);
      k.Read(s[1], messagesize);
      s := trim(s);
      if (trim(s)[1] <> 'I') then
      begin
        if length(s) > 2 then if (s[1] = '&') and (s[2] = '&') then Delete(s, 1,2);
        showbericht(s)
      end 
      else
      begin
        beller(s);
        if fanswer then 
        begin 
          active := True;
          sendmessage('^Connected');
          ftimer.Enabled := False 
        end;
        if assigned(fcalled) then fcalled(Sender, s);
      end
    end 
    else
    begin
      h := False;
      if assigned(fbeforesoundout) then
      begin
        getmem(p, k.size);
        move(k.memory^, p^, k.size);
        groot := k.size;
        fbeforesoundout(p, groot, h);
        if h then
          try
            acmout1.play(p, groot);
          finally
            freemem(p)
          end;
        freemem(p)
      end;

      if (not h) and ((random(1200) > fsyncfactor) or (not fsync)) then
        acmout1.Play(k.memory, k.size);
      if assigned(fsoundrecieved) then fsoundrecieved(self, fromip);
    end;
  finally
    k.Clear;
    k.Free
  end
end;


procedure Ttelefoon.start;
var 
  format: pointer;
  maxsizeformat: longint;
  F: Tacmwaveformat;
  g: tacmconvertor;
  e: Exception;
  origformat: pWaveFormatEX;
  x: integer;
  b: boolean;
  s: array[1..256] of byte;
begin
  if fzelf then
  begin
    g := Tacmconvertor.Create(self);
    b := g.chooseformat(f, False);
  end
  else
  begin
    GetMem(OrigFormat, Sizeof(TACMWaveFormat));
    x := Ord(fverbinding) + 1;
    b := True;
    case x of
      1:
        with origformat^ do 
        begin
          wformattag := 4353; //efficient l& h 4.8        1kb
          nchannels := 1;
          nsamplespersec := 8000;
          navgbytespersec := 600;
          nblockalign := 12;
          wbitspersample := 16;
          cbsize := 0;
          f.format := origformat^
        end;
      2: with OrigFormat^ do 
        begin
          wFormatTag := 1;   // pcm  8kb
          nChannels := 1;     // Mono
          nSamplesPerSec := 8000; //Low enough to strean
          nAvgBytesPerSec := 8000;
          nBlockAlign := 1;
          wbitspersample := 8;
          cbSize := 46593;
          f.Format := origformat^;
        end;
      3:
        with origformat^ do 
        begin
          wformattag := 49; // gsm 6.10 2kb
          nchannels := 1;
          nsamplespersec := 8000;
          navgbytespersec := 1625;
          nblockalign := 65;
          wbitspersample := 0;
          cbsize := 2;
          move(origformat^, s, Sizeof(TACMWaveFormat));
          s[18] := 0;
          s[19] := 64;
          s[20] := 1;
          move(s, f.format, sizeof(Tacmwaveformat));
        end;
      4:
        with origformat^ do 
        begin
          wformattag := 1; //pcm 22 (radiokwaliteit)
          nchannels := 1;
          nsamplespersec := 22050;
          navgbytespersec := 22050;
          nblockalign := 1;
          wbitspersample := 8;
          cbsize := 0;
          f.format := origformat^
        end;
      5:
        with origformat^ do 
        begin
          wformattag := 1; //pcm 11telefoonkwaliteit
          nchannels := 1;
          nsamplespersec := 11025;
          navgbytespersec := 11025;
          nblockalign := 1;
          wbitspersample := 8;
          cbsize := 0;
          f.format := origformat^
        end;
      6:
        with origformat^ do 
        begin
          wformattag := 4354; //lernout8
          nchannels := 1;
          nsamplespersec := 8000;
          navgbytespersec := 1850;
          nblockalign := 37;
          wbitspersample := 16;
          cbsize := 0;
          f.format := origformat^
        end;
    end;
    freemem(origformat)
  end;
  if b then 
  begin
    acmin1.BufferSize := trunc(f.Format.nAvgBytesPerSec / bufferdelen);

    if acmin1.buffersize <= f.format.nblockalign then
      acmin1.BufferSize := f.format.nblockalign * 2;
    if acmin1.buffersize > 1900 then acmin1.buffersize := 1900;
    if acmin1.buffersize = messagesize then acmin1.BufferSize := messagesize + 65;
    try
      ACMOut1.Open(f);
      ACMIn1.Open(f);
      if assigned(fsoundstart) then fsoundstart(self, 'soundstart');
    except 
      on e: Exception do
      begin
        factive := False;
        ACMIn1.Close;
        ACMOut1.Close;
        if assigned(fsoundclose) then fsoundclose(self);
        if assigned(fcodecerror) then fcodecerror(self, e.Message) 
        else
          ShowMessage(e.Message);
      end;
    end;
  end 
  else 
    factive := False
end;

procedure Ttelefoon.setip(const Value: string);
begin
  if assigned(nm) then
  begin
    fip := Value;
    nm.remotehost := Value
  end
end;

procedure Ttelefoon.setactive(const Value: boolean);
begin
  begin
    if not Value then ftimer.Enabled := False;
    if not (Value and factive) then
      if Value = True then 
        try 
          factive := True;
          start  
        except 
        end 
      else 
      begin 
        stop;
        factive := False 
      end;
  end
end;

procedure Ttelefoon.setport(const Value: integer);
begin
  if assigned(nm) then
  begin
    fport := Value;
    nm.remoteport := Value
  end;
end;

procedure Ttelefoon.setauthor(const Value: string);
begin
  fauthor := 'remko_voip@prinsengracht.org';
end;

procedure Ttelefoon.setversion(const Value: string);
begin
  fversie := 'Version 0.90';
end;

procedure Ttelefoon.ACMIn1BufferFull(Sender: TObject; Data: Pointer;
  Size: integer);
var 
  k: Tmemorystream;
  p: pointer;
  s: integer;
  h: boolean;
  oldsize: integer;
begin
  k := tmemorystream.Create;
  k.Clear;
  oldsize := size;
  try
    if assigned(fselfsound) then
    begin
      fselfsound(p, size, h);
      if h and (size > 0) then 
      begin 
        k.Write(p^, size);
        freemem(p) 
      end 
      else 
        k.Write(Data^, oldsize)
    end 
    else
      k.Write(Data^, size);
    if not fmute then if (random(1200) > fsyncfactor) or (not fsync) then nm.Sendstream(k);
  finally
    k.Clear;
    k.Free
  end
end;

procedure Ttelefoon.setlocalport(const Value: integer);
begin
  if assigned(nm) then
  begin
    flocal := Value;
    nm.localport := Value
  end;
end;

procedure Ttelefoon.nmStatus(Sender: TComponent; status: string);
begin
  if assigned(fstatus) then fstatus(Sender, status)
end;

procedure Ttelefoon.nmDataSend(Sender: TObject);
begin
  if assigned(fverzonden) then fverzonden(Sender, timetostr(time))
end;

procedure Ttelefoon.stop;
begin
  ACMIn1.Close;
  ACMOut1.Close;
  if assigned(fsoundclose) then fsoundclose(self);
end;

procedure Ttelefoon.ping(ip, naam: string);
var 
  a: array[1..60] of char;
  s: string;
  i: integer;
  tip, pingport: string;
begin
  try
    tip := '';
    pingport := '';
    i := 1;
    while (i <= length(ip)) and (ip[i] <> ':') do
    begin
      tip := tip + ip[i];
      i := i + 1
    end;
    nmping.remotehost := tip;
    if ip[i] = ':' then
    begin
      i := i + 1;
      while (i <= length(ip)) and (ip[i] <> ':') do i := i + 1;
      if ip[i] = ':' then
      begin
        i := i + 1;
        while i <= length(ip) do
        begin
          pingport := pingport + ip[i];
          i := i + 1
        end
      end;
      try
        if trim(pingport) <> '' then fpingremote := StrToInt(pingport);
      except
      end;
    end;
    nmping.LocalPort := fpinglocal;
    nmping.remoteport := fpingremote;
    if trim(flocalip) = '' then vernieuwlocal;
    s := 'I' + flocalip + 'P' + IntToStr(flocal) + 'V' + IntToStr(Ord(fverbinding)) +
      'Q' + IntToStr(fpingremote);
    if factive then s := s + 'AT' 
    else 
      s := s + 'AF';
    if fanswer then s := s + 'OT' 
    else 
      s := s + 'OF';
    if length(naam) > 20 then setlength(naam, 20);
    s := s + 'N' + naam;
    s := s + '@';
    for i := 1 to length(s) do a[i] := s[i];
    nmping.sendbuffer(a, 60)
  except
  end;
end;

procedure Ttelefoon.beller(var s: string);
var 
  a, b: string;
  e, f: integer;
  g: string;
begin
  gip := fip;
  gport := fport;
  gconnect := fverbinding;
  Gzelf := fzelf;
  e := 1;
  g := '';
  f := 0;
  b := '';
  while (e <= length(s)) and (f <> 5) do
  begin
    if (f = 1) and (s[e] <> 'P') then gip := gip + s[e];
    if (f = 2) and (s[e] <> 'V') then b := b + s[e];
    if (f = 3) and (s[e] <> 'Z') then gconnect := Tverbinding(StrToInt(s[e]));
    if (f = 4) and (e < length(s)) and (s[e] <> '@') then if s[e] = 'T' then gzelf := True 
      else 
        gzelf := False;
    if s[e] = 'I' then 
    begin 
      gip := '';
      f := 1 
    end;
    if s[e] = 'P' then 
    begin 
      gport := 0;
      f := 2 
    end;
    if s[e] = 'V' then 
    begin 
      f := 3;
      try 
        gport := StrToInt(b) 
        except 
      end 
    end;
    if s[e] = 'Z' then 
    begin 
      gzelf := False;
      f := 4 
    end;
    if s[e] = '@' then f := 5;
    if f < 5 then g := g + s[e];
    e := e + 1
  end;
  s := g;
  if fauto and (not factive) then
  begin
    fip := gip;
    fport := gport;
    fverbinding := gconnect;
    fzelf := gzelf;
    if local_ip = '' then vernieuwlocal;
    nm.RemoteHost := fip;
    nm.RemotePort := fport;
  end;
end;

procedure Ttelefoon.placecall(ip: string);
var 
  i: integer;
  tip, poort: string;
  voorpunt: boolean;
begin
  tip := '';
  poort := '';
  i := 1;
  voorpunt := True;
  while i <= length(ip) do
  begin
    if voorpunt and (ip[i] <> ':') then tip := tip + ip[i];
    if (not voorpunt) and (ip[i] <> ':') then poort := poort + ip[i];
    if (not voorpunt) and (ip[i] = ':') then i := 1000;
    if ip[i] = ':' then voorpunt := False;
    i := i + 1
  end;
  fip := tip;
  try
    if trim(poort) <> '' then fport := StrToInt(poort);
  except
    fport := 8000
  end;
  if trim(ip) <> '' then remote_ip := fip;
  calling := True
end;

procedure Ttelefoon.setbellen(const Value: boolean);
var 
  k: Tmemorystream;
  s: string;
begin
  if Value then
  begin
    if not factive then
    begin
      if trim(local_ip) = '' then vernieuwlocal;
      nm.remotehost := fip;
      nm.RemotePort := fport;
      k := tmemorystream.Create;
      try
        s := 'I' + flocalip + 'P' + IntToStr(flocal) + 'V' + IntToStr(Ord(fverbinding)) + 'Z';
        if fzelf then s := s + 'T' 
        else 
          s := s + 'F';
        s := s + '@';
        k.SetSize(messagesize);
        k.Write(s[1], length(s));
        nm.Sendstream(k);
      finally
        k.Clear;
        k.Free
      end;
      if not fbellen then ftimer.Enabled := True;
      fbellen := True;
      active := True;
    end 
    else 
      ShowMessage('U are already in a call')
  end 
  else
  begin
    fbellen := False;
    if active then
    begin
      try
        active := False;
        k := tmemorystream.Create;
        s := '~Connection ended.@';
        k.SetSize(messagesize);
        k.Write(s[1], length(s));
        nm.Sendstream(k);
        if assigned(fended) then fended(self, s)
        finally
          k.Clear;
        k.Free;
      end
    end;
  end
end;


procedure Ttelefoon.sendmessage(s: string);
var 
  k: tmemorystream;
begin
  if factive then
  begin
    s := '&&' + s + '@';
    k := tmemorystream.Create;
    if length(s) < messagesize then
      try
        k.SetSize(messagesize);
        setlength(s, messagesize);
        k.Write(s[1], length(s));
        nm.Sendstream(k);
      finally
        k.Clear;
        k.Free
      end
  end
end;

procedure Ttelefoon.showbericht(s: string);
var 
  P: string;
  i: integer;
  einde: boolean;
  conn: boolean;
  rej: boolean;
begin
  einde := False;
  p := '';
  i := 1;
  conn := False;
  rej := False;
  while i <= length(s) do
  begin
    if s[i] = '~' then 
    begin 
      einde := True;
      calling := False;
      active := False 
    end;
    if s[i] = '^' then 
    begin 
      conn := True;
      s[i] := ' ' 
    end;
    if s[i] = '|' then 
    begin 
      rej := True;
      calling := False;
      active := False;
      s[i] := ' ' 
    end;
    if (s[i] <> '@') and (s[i] <> '~') then p := p + s[i] 
    else if s[i] = '@' then i := 1000;
    i := i + 1;
  end;
  if rej then ftimer.Enabled := False;
  if conn then ftimer.Enabled := False;
  p := trim(p);
  if conn and assigned(faccepted) then faccepted(self, p) 
  else if einde then
  begin
    if assigned(fended) then fended(self, p) 
    else 
      ShowMessage(p)
  end 
  else if rej then
  begin
    if assigned(frejected) then frejected(self, p) 
    else 
      ShowMessage(p)
  end 
  else if assigned(fsms) then fsms(self, p) 
  else 
    ShowMessage(p);
end;

procedure Ttelefoon.answer;
begin
  active := True
end;

procedure Ttelefoon.setvolume(Value: integer);
var 
  res: mmresult;
  v: dword;
  a: integer;
begin
  if active then
  begin
    a := Value * 655 - 1;
    a := a * 65536 + a;
    v := dword(a);
    fvolume := Value;
    waveoutsetvolume(acmout1.FWaveOutHandle, v);
  end
end;

function Ttelefoon.getvolume: integer;
var 
  v: pdword;
  res: mmresult;
  negatief: boolean;
  b, c: integer;
begin
  Result := fvolume;
  if active then
  begin
    res := 0;

    res := waveOutGetVolume(acmout1.FWaveOutHandle, @v);
    c := integer(v);
    if c < 0 then negatief := True 
    else 
      negatief := False;
    c := trunc(c / 65536);
    if negatief then c := c + 65536;
    c := trunc(c / 655);
    if integer(res) <> 0 then Result := 0 
    else 
      Result := integer(c)
  end
end;


function Ttelefoon.getmikevolume: integer;
var 
  v: pdword;
  res: mmresult;
  negatief: boolean;
  b, c: integer;
begin
  Result := fvolume;
  if active then
  begin
    res := 0;
    res := waveOutGetVolume(acmin1.FWaveinHandle, @v);
    c := integer(v);
    if c < 0 then negatief := True 
    else 
      negatief := False;
    c := trunc(c / 65536);
    if negatief then c := c + 65536;
    c := trunc(c / 655);
    if integer(res) <> 0 then Result := 0 
    else 
      Result := integer(c)
  end
end;




procedure Ttelefoon.setlocalpingport(const Value: integer);
begin
  fpinglocal := Value;
  if assigned(nmping) then nmping.localport := Value
end;

function Ttelefoon.test: integer;
var 
  p: pdword;
  res: mmresult;
begin
  res := waveOutGetPlaybackRate(acmout1.FWaveOutHandle, @p);
  Result := integer(p)
end;

procedure Ttelefoon.setremotepingport(const Value: integer);
begin
  fpingremote := Value;
  if assigned(nmping) then nmping.RemotePort := Value
end;

procedure Ttelefoon.answerincomming;
begin
  active := True;
  ftimer.Enabled := False;
  sendmessage('^Connected')
end;

procedure Ttelefoon.rejectincomming;
var 
  k: tmemorystream;
  s: string;
begin
  try
    ftimer.Enabled := False;
    k := tmemorystream.Create;
    s := '|Call rejected@';
    k.SetSize(messagesize);
    k.Write(s[1], length(s));
    nm.Sendstream(k);
  finally
    k.Clear;
    k.Free;
  end
end;

function Ttelefoon.getwait: integer;
begin
  Result := trunc(fwait / 1000);
end;

procedure Ttelefoon.setwait(Value: integer);
begin
  fwait := Value * 1000;
end;


function Ttelefoon.getsoundinlevel: longint;
var 
  left, right: dword;
begin
  Result := 0;
  left := 11;
  right := 10;
  if factive then
    if fmix.mixer.getmeter(1,2,left, right) then Result := trunc((left + right) / 2);
  if left <> right then Result := -1
end;


procedure Register;
begin
  RegisterComponents('remko', [TTelefoon]);
end;

end.
